<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - SUIF Objects</TITLE>
<link href="suif1_84.html" rel=Next>
<link href="suif1_82.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_82.html">previous</A>, <A HREF="suif1_84.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC83" HREF="suif1_toc.html#TOC83">SUIF Objects</A></H2>
<P>
<A NAME="IDX602"></A>
<A NAME="IDX603"></A>

</P>
<P>
<A NAME="IDX604"></A>
Most of the significant classes in the SUIF library are derived from a
common base class.  This <CODE>suif_object</CODE> class includes a field with
a pointer to a list of annotations.  Thus, annotations can be attached
to most objects in SUIF, and all of these objects share the same
interface for accessing the annotations.  The files <TT>`suifobj.h'</TT> and
<TT>`suifobj.cc'</TT> contain the code for the <CODE>suif_object</CODE> class.

</P>
<P>
<A NAME="IDX605"></A>
<A NAME="IDX606"></A>
Besides the annotation list, each <CODE>suif_object</CODE> has a field to
identify the kind of the object.  The <CODE>object_kind</CODE> method
retrieves the value from this field.  The <CODE>object_kinds</CODE> enumerated
type defines the possible values:

</P>
<DL COMPACT>

<DT><CODE>FILE_OBJ</CODE>
<DD>
File set entry.  See section <A HREF="suif1_9.html#SEC9">File Set Entries</A>.

<DT><CODE>TREE_OBJ</CODE>
<DD>
Abstract syntax tree node.  See section <A HREF="suif1_11.html#SEC11">Tree Nodes</A>.

<DT><CODE>INSTR_OBJ</CODE>
<DD>
SUIF instruction.  See section <A HREF="suif1_22.html#SEC22">Instructions and Expression Trees</A>.

<DT><CODE>SYMTAB_OBJ</CODE>
<DD>
Symbol table.  See section <A HREF="suif1_40.html#SEC40">Symbol Tables</A>.

<DT><CODE>SYM_OBJ</CODE>
<DD>
Symbol node.  See section <A HREF="suif1_51.html#SEC51">Symbols</A>.

<DT><CODE>DEF_OBJ</CODE>
<DD>
Variable definition.  See section <A HREF="suif1_58.html#SEC58">Variable Definitions</A>.

<DT><CODE>TYPE_OBJ</CODE>
<DD>
Type node.  See section <A HREF="suif1_59.html#SEC59">Types</A>.
</DL>

<P>
<A NAME="IDX607"></A>
<A NAME="IDX608"></A>
The rest of the methods in the <CODE>suif_object</CODE> class are related to
handling annotations.  First of all, the <CODE>are_annotations</CODE> method
checks to see if an object has any annotations attached to it.  If so,
the <CODE>annotes</CODE> method can be used to retrieve a pointer to the list
of annotations.  Do not just grab the list of annotations and check to
see if it is empty, but use <CODE>are_annotations</CODE> instead.  Since many
objects don't have any annotations, the library doesn't allocate
annotation lists unless they are needed.  Calling <CODE>annotes</CODE> will
create a new list if one did not already exist, so to avoid creating a
lot of empty lists use <CODE>are_annotations</CODE> first.

</P>
<P>
<A NAME="IDX609"></A>
<A NAME="IDX610"></A>
<A NAME="IDX611"></A>
The <CODE>prepend_annote</CODE> and <CODE>append_annote</CODE> methods are a
convenient way to add new annotations to an object.  They simply create
a new annotation using the specified name and data and then add it to
the beginning or end, respectively, of the annotation list.  If the
object is only supposed to have one annotation with a particular name,
the <CODE>set_annote</CODE> method works well for assigning new values for
that annotation.  If the object already has an annotation with the
specified name, <CODE>set_annote</CODE> will replace the existing one (or the
first one that it finds); otherwise, it just adds the new annotation at
the end of the list.

</P>
<P>
<A NAME="IDX612"></A>
<A NAME="IDX613"></A>
There are two different methods to retrieve data from annotations
attached to an object.  The first, <CODE>peek_annote</CODE>, simply returns
the data field from the first annotation that it finds with the
specified name.  If it doesn't find any annotations with that name, it
returns a <CODE>NULL</CODE> pointer.  The <CODE>get_annote</CODE> method does the
same thing except that it is destructive.  Besides returning the data
from the annotation, it also removes the annotation from the list and
destroys it.  Note that with these methods it is impossible to
distinguish the case where an annotation exists but has a <CODE>NULL</CODE>
data field from the case where the annotation does not exist.  If you
want to retrieve the actual annotation objects instead of just their
data fields, the annotation list (see section <A HREF="suif1_84.html#SEC84">Annotation Lists</A>) provides
<CODE>peek_annote</CODE> and <CODE>get_annote</CODE> methods to do that.

</P>
<P>
<A NAME="IDX614"></A>
When some kinds of SUIF objects (e.g. symbols and types) are copied, the
annotations are omitted.  If you want to copy the annotations as well as
the base objects, the <CODE>copy_annotes</CODE> method must be called
separately.  This method works for any two SUIF objects; they do not
have to be the same kind.  If the target object already has some
annotations, the new ones are appended to the end of the list.
Unregistered annotations are not copied.

</P>
<P>
<A NAME="IDX615"></A>
The <CODE>suif_object</CODE> class provides a <CODE>print_annotes</CODE> method for
printing the annotation list to a text file.  This is used by the
<CODE>print</CODE> methods for the derived classes, but it could also be used
directly by users.  The optional <CODE>depth</CODE> parameter specifies the
indentation level.  Beware that a new-line character is printed
<EM>before</EM> each annotation and thus you probably want to print a
new-line after calling this method.

</P>
<P>
<A NAME="IDX616"></A>
The <CODE>num_output_annotes</CODE> method checks to see if an object has any
annotations, and if so, it counts the ones that will be written to the
output file.  This is primarily used by the SUIF library and most users
will not need it.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_82.html">previous</A>, <A HREF="suif1_84.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
